#######################################################################
# Program Id    :	QS11.4gl                                          #	
# Form Name     :	QS101.per                                         #
# Description   :	Cetakan Penyata Gaji                              #
# Date Created	:	04/12/2009 & 17/01/2010, 18/01/2010(PDF),20/01/01 #
# Modified      :   23/07/2010 - if post_type "D", separate print slip# 
#                   gaji based on user_cmpy                           #
#                   url add seq no, printpdf, printx(php)
#                   05/11/2010 - session id             #
#                   13/10/2011 - expand no staf kepada 8 character
#######################################################################

DATABASE portaldb

GLOBALS
	DEFINE	cmpy			LIKE company.cmpy_code,
            cmpy1           CHAR(4),
			whom			LIKE maxuser.sign_on_code,
			where_part		CHAR(300),
			query_text		CHAR(400),
			pr_desc_text	CHAR(40),
			pr_output		CHAR(80),
			pr_paydate		DATE,
			mth				DATETIME YEAR TO MONTH,
			pr_empayprd		RECORD LIKE empayprd.*,
			pr_employee		RECORD LIKE employee.*,
			pr_payctrl		RECORD LIKE payctrl.*,
			pr_paypostrun	RECORD LIKE paypostrun.*,
            varEmpID        CHAR(10),
			pdfname			CHAR(80),
            get_emp_no STRING,
            n_get_emp_no CHAR (20),
      	    proses ,flag  		CHAR(01),
            lbllink STRING,
            valuelbl STRING,
            p_text CHAR(100),
            ipcode			CHAR(20),
            cnt_ptg     INTEGER,
            idx_p       INTEGER,
            idx1, idx_a  INTEGER,
            g_date,slip_date,day_today DATE,
            n_get_username	    char(40),
            n_get_menu_code     char(03),
            sessid      LIKE staffinf.session_id
            
          

END GLOBALS

MAIN
CALL ui.Interface.loadStyles("mystyles")
WHENEVER ERROR CALL chksqlst
    LET get_emp_no ="170040"
    LET n_get_emp_no = get_emp_no    
    {LET sessid =arg_val(1)
               
        SELECT staffinf.idnumber, staffinf.username, security.menu_code 
        INTO  n_get_emp_no, n_get_username, n_get_menu_code
        FROM  staffinf, security 
        WHERE staffinf.username = security.user_id
        AND staffinf.session_id = sessid
        AND staffinf.cmpycode = security.cmpy_code
        AND security.menu_code = "S11"
        
    IF NOT(ChkSQLSt()) THEN
       LET p_text = "SILA LOGIN DARI FINEPORTAL!!!!!! "
       call menu_err(p_text)
       EXIT PROGRAM
    END IF
    
    CALL log(sessid)
    }
    SELECT employee.cmpy_code
    INTO   cmpy1
    FROM   employee
    WHERE  employee.emp_no = n_get_emp_no
    
    SELECT cmpy_code
    INTO   cmpy
    FROM   payctrl
    WHERE  payctrl.payroll_cmpy = cmpy1
    
    SELECT  potparm.ip_code
    INTO    ipcode
    FROM    potparm
    WHERE   potparm.sys_code = '2'
    
    CALL ui.Form.setDefaultInitializer("myinit")
  
	DEFER INTERRUPT
	DEFER QUIT

	OPTIONS	INPUT WRAP
      
    CLOSE WINDOW SCREEN
	OPEN WINDOW wS215 WITH FORM "QS101"
	ATTRIBUTE (BORDER,MESSAGE LINE 2, TEXT="Cetakan Slip Gaji")

    DISPLAY n_get_emp_no TO empayprd.emp_no

     WHILE input_data()
         END WHILE
   
END MAIN

FUNCTION input_data()
DEFINE cnt_a    smallint

    LET pr_empayprd.emp_no = n_get_emp_no
	IF pr_empayprd.emp_no IS NOT NULL THEN
		SELECT emp_name INTO pr_employee.emp_name FROM employee
		WHERE	emp_no  = pr_empayprd.emp_no
		IF STATUS = 100 THEN
			 LET p_text = "Kakitangan tidak wujud"  
             CALL menu_err (p_text)
        END IF
	END IF

  
    DISPLAY pr_empayprd.emp_no
    DISPLAY BY NAME pr_employee.emp_name
    
	SELECT last_prd 
    INTO   pr_payctrl.last_prd 
    FROM   payctrl
	WHERE  payctrl.cmpy_code=cmpy

	#LET pr_empayprd.pay_prd = pr_payctrl.last_prd
	#LET pr_empayprd.post_type = "A"

	INPUT BY NAME	pr_empayprd.post_type,
					pr_empayprd.pay_prd
					WITHOUT DEFAULTS

    
    BEFORE FIELD pay_prd
    LET pr_empayprd.pay_prd = pr_payctrl.last_prd
    DISPLAY BY NAME pr_empayprd.pay_prd
    LET flag = FALSE 
    IF NOT flag THEN
    display "" to f01
    END IF

    AFTER FIELD pay_prd
     LET pr_empayprd.pay_prd = get_fldbuf(pay_prd)
  	IF pr_empayprd.pay_prd IS NULL THEN
		LET p_text = "Bulan prosesan tidak sah"  
        CALL menu_err (p_text)
        NEXT FIELD pay_prd
	END IF
    
    # tak perlu check cmpy yg lain sbb bile run gaji last prd semua sama utk semua KW - info 22/07/10
	SELECT last_prd 
    INTO   pr_payctrl.last_prd 
    FROM   payctrl
	WHERE  payctrl.cmpy_code=cmpy

    IF pr_empayprd.post_type = "X" OR pr_empayprd.post_type = "Y" THEN
    ELSE
	IF pr_payctrl.last_prd < pr_empayprd.pay_prd THEN
		LET p_text = "Gaji belum diproses bagi jangkamasa ...."  
        CALL menu_err (p_text)
        NEXT FIELD pay_prd
	END IF
    END IF
    DISPLAY BY NAME pr_empayprd.pay_prd
    
    ON CHANGE post_type
    ------------------
    NEXT FIELD pay_prd

    {BEFORE FIELD post_type
    ---------------------
    LET pr_empayprd.post_type ="A"
    DISPLAY BY NAME pr_empayprd.post_type}
    
    AFTER FIELD post_type
    ---------------------
    LET pr_empayprd.post_type = get_fldbuf(post_type)
    IF pr_empayprd.post_type = " " OR pr_empayprd.post_type IS NULL THEN
        LET p_text = "Sila Pilih Jenis Penyata Gaji Terlebih Dahulu"
        CALL menu_err(p_text)
        NEXT FIELD post_type
    END IF
       
    AFTER INPUT
    --------------
    LET flag = TRUE
    
    {
    SELECT TRUE
    FROM  empayprd
    WHERE empayprd.pay_prd = pr_empayprd.pay_prd
    AND   empayprd.emp_no  = n_get_emp_no
    AND   empayprd.post_type = pr_empayprd.post_type
    
    IF STATUS = 100 THEN
		LET p_text = "Tiada Maklumat Gaji..."  
        CALL menu_err (p_text)
        NEXT FIELD post_type#pay_prd
	END IF
    }#remark 22/07/2010
    LET cnt_a = 0
    
    SELECT COUNT(*)
    INTO cnt_a
    FROM  empayprd
    WHERE empayprd.pay_prd = pr_empayprd.pay_prd
    AND   empayprd.emp_no  = n_get_emp_no
    AND   empayprd.post_type = pr_empayprd.post_type
  
  
  #sikin  LET lbllink ="<div align='right'><a target=\"_self\" href='http://",ipcode clipped,"/uitm/report/slipgaji/printpdf.php?id=",n_get_emp_no USING "<<<<<<<" CLIPPED,"@",cnt_a USING "<<" CLIPPED,"'><img src='http://",ipcode clipped,"/uitm/report/images/printer3.bmp' border='0'></img></a></div>"
 #komen jap 05102010 LET lbllink ="<div align='right'><a target=\"_self\" href='http://",ipcode clipped,"/uitm/report/slipgaji/printpdf.php?id=",sessid CLIPPED,"@",cnt_a USING "<<" CLIPPED,"'><img src='http://",ipcode clipped,"/uitm/report/images/printer3.bmp' border='0'></img></a></div>"
  --LET lbllink ="<div align='right'><a target=\"_self\" href='http://",ipcode clipped,"/new/printpdf.php?id=",sessid CLIPPED,"@",cnt_a USING "<<" CLIPPED,"'><img src='http://",ipcode clipped,"/new/report/images/printer3.bmp' border='0'></img></a></div>"
 LET lbllink ="<a href='http://",ipcode clipped,"/new/printpdf.php?id=",sessid CLIPPED,"@",cnt_a USING "<<" CLIPPED,"'>PRINT</a>"

    IF cnt_a <= 0  THEN
		LET p_text = "Tiada Maklumat Gaji."  
        CALL menu_err (p_text)
        NEXT FIELD post_type#pay_prd
	END IF
    
    # tak perlu check cmpy sbb semua refer "SA"
    IF pr_empayprd.post_type = "A" OR pr_empayprd.post_type = "X" THEN
    SELECT payslipdate.date
    INTO g_date
    FROM payslipdate
    WHERE post_type = pr_empayprd.post_type
    AND MONTH(payslipdate.date) = MONTH(pr_empayprd.pay_prd)
    AND YEAR(payslipdate.date) = YEAR(pr_empayprd.pay_prd)
    AND payslipdate.cmpy_code = "SA"
    ELSE
    IF pr_empayprd.post_type = "T" THEN
    SELECT payslipdate.date
    INTO g_date
    FROM payslipdate
    WHERE post_type = pr_empayprd.post_type
    AND MONTH(payslipdate.date) = MONTH(pr_empayprd.pay_prd)
    AND YEAR(payslipdate.date) = YEAR(pr_empayprd.pay_prd)
    AND payslipdate.cmpy_code = "SA"
    ELSE
    SELECT payslipdate.date
    INTO g_date
    FROM payslipdate
    WHERE post_type = pr_empayprd.post_type
    AND MONTH(payslipdate.date) = MONTH(pr_empayprd.pay_prd)
    AND YEAR(payslipdate.date) = YEAR(pr_empayprd.pay_prd)
    AND  payslipdate.cmpy_code = cmpy 
    END IF
    END IF
    
    LET slip_date = (g_date - 4 UNITS DAY)
    LET day_today = TODAY
    --LET p_text = slip_date
    --CALL menu_err(p_text)

    --LET p_text = day_today
    --CALL menu_err(p_text)
    IF day_today < slip_date THEN
    LET p_text = "Slip Gaji Hanya Boleh DiJana Mulai...",slip_date  
        CALL menu_err (p_text)
        NEXT FIELD pay_prd#pay_prd
    END IF

    END INPUT

	 IF  int_flag OR quit_flag THEN
	     RETURN FALSE
	  END IF

       IF flag THEN
      CALL slip_printing()
      ELSE display "" to f01
      END IF
   
RETURN TRUE       
    
END FUNCTION


FUNCTION slip_printing()

	DEFINE	pay_mth	CHAR(20),
			bln		SMALLINT,
            a_cnt   SMALLINT,
            myfile, cmd  CHAR(100),
            p_status    SMALLINT,
            
            pay_cmpy    LIKE empayprd.user_cmpy

	IF (pr_empayprd.post_type = "B" OR 
        pr_empayprd.post_type = "D" ) THEN
	   LET bln = MONTH(pr_empayprd.pay_prd + 1 UNITS MONTH)
    ELSE
	   LET bln = MONTH(pr_empayprd.pay_prd)
    END IF

	CASE bln
	WHEN 1
		LET pay_mth = "JANUARI"
	WHEN 2
		LET pay_mth = "FEBRUARI"
	WHEN 3
		LET pay_mth = "MAC"
	WHEN 4
		LET pay_mth = "APRIL"
	WHEN 5
		LET pay_mth = "MEI"
	WHEN 6
		LET pay_mth = "JUN"
	WHEN 7
		LET pay_mth = "JULAI"
	WHEN 8
		LET pay_mth = "OGOS"
	WHEN 9
		LET pay_mth = "SEPTEMBER"
	WHEN 10
		LET pay_mth = "OKTOBER"
	WHEN 11
		LET pay_mth = "NOVEMBER"
	WHEN 12
		LET pay_mth = "DISEMBER"
	END CASE

    #tambah baru true kepala angin
    IF (pr_empayprd.post_type = "B" OR pr_empayprd.post_type = "D")
        AND bln = '1' THEN
	   LET pay_mth = pay_mth CLIPPED," ",(EXTEND(pr_empayprd.pay_prd,YEAR TO YEAR) + 1 UNITS YEAR) #USING "&&&&"
    ELSE
	   LET pay_mth = pay_mth CLIPPED," ",YEAR(pr_empayprd.pay_prd) USING "&&&&"
    END IF
	
    #LET pay_mth = pay_mth CLIPPED," ",YEAR(pr_empayprd.pay_prd) USING "&&&&"
    {SELECT count(user_cmpy)
    INTO a_cnt
    FROM empayprd
    WHERE	emp_no = pr_empayprd.emp_no 
    AND     pay_prd = pr_empayprd.pay_prd 
    AND     post_type = pr_empayprd.post_type
    }
    
    
        
        --let myfile = "/usr/local/apache/htdocs/uitm/report/slipgaji/" clipped, n_get_emp_no USING "<<<<<<<" clipped,"*.html"     
        let cmd = "rm /usr/local/apache/htdocs/new/report/slipgaji/" clipped, n_get_emp_no USING "<<<<<<<<" clipped,"*.html"   
        --let cmd = "rm /home/shikin/penyata_pcb.txt"
        run cmd returning p_status
        
    LET a_cnt = 0
    
    DECLARE g_slip CURSOR FOR
    SELECT user_cmpy FROM empayprd
    WHERE	emp_no = pr_empayprd.emp_no 
    AND     pay_prd = pr_empayprd.pay_prd 
    AND     post_type = pr_empayprd.post_type
    
    FOREACH g_slip INTO pay_cmpy
    
            LET a_cnt = a_cnt + 1
            
            DECLARE c_slip CURSOR FOR
            SELECT * FROM empayprd
            WHERE	emp_no = pr_empayprd.emp_no 
            AND     pay_prd = pr_empayprd.pay_prd 
            AND     post_type = pr_empayprd.post_type
            #additional
            AND user_cmpy = pay_cmpy

            LET pr_output = "/usr/local/apache/htdocs/new/report/slipgaji/",n_get_emp_no USING "<<<<<<<<" CLIPPED,"_" , a_cnt using "<<" CLIPPED,".html"

            START REPORT S2P_list TO pr_output
            #START REPORT S2P_list TO "/mnt1/fais/report/"||get_emp_no||".txt"

        {	SELECT  post_date 
            INTO    pr_paypostrun.post_date 
            FROM    paypostrun
            WHERE	pay_prd = mth 
            AND     post_type = pr_empayprd.post_type 
        }
            FOREACH c_slip INTO pr_empayprd.*

                SELECT a.* 
                INTO pr_employee.* 
                FROM employee a
                WHERE a.emp_no = n_get_emp_no

                OUTPUT TO REPORT S2P_list(pr_empayprd.*,pr_employee.*,pay_mth)
            END FOREACH

            FINISH REPORT S2P_list
            
    END FOREACH
     
    
    DISPLAY lbllink TO f01

    {    MENU "Cetakan Slip Gaji"
          COMMAND ""
       END MENU
                
    CLOSE WINDOW w1
    }
  
END FUNCTION

FUNCTION menu_err (r_text)
DEFINE
	r_text		CHAR(100)


        MENU  "Pemberitahuan" 
	    ATTRIBUTE ( STYLE="dialog", COMMENT=p_text clipped)
            COMMAND "OK"
            EXIT MENU
        END MENU


END FUNCTION  # menu_err ()
{

FUNCTION setup_parms()

	DEFINE	i	SMALLINT,
			kk	char(500)

	let kk = "echo ",arg_val(1)," ",arg_val(2)," ",arg_val(3)," > rd.out"
	run kk
    LET where_part = arg_val(1)
	LET mth		   = arg_val(2)
	LET pr_paydate = arg_val(3)

	FOR i = 1 TO LENGTH(where_part)
		IF where_part[i,i] = "@" THEN
  			LET where_part[i,i] = "\""
  		END IF
	END FOR

END FUNCTION

}
REPORT S2P_list(pr_empayprd,pr_employee,pay_mth)

	DEFINE	pr_empayprd		RECORD LIKE empayprd.*,
			pr_employee	    RECORD LIKE employee.*,
			pr_bank		    RECORD LIKE bank.*,
			pr_empayldgr	RECORD LIKE empayldgr.*,
			pr_allded		RECORD LIKE allded.*,
			pr_alldedprd	RECORD LIKE alldedprd.*,
			pr_post			RECORD LIKE post.*,
			pr_tempcost	    RECORD LIKE tempcost.*,
			pa_empayldgr	ARRAY[50] OF RECORD
				all_desc	CHAR(35) ,  #sikin LIKE allded.short_desc,
				all_amt		DECIMAL(8,2),
				ded_desc	LIKE allded.short_desc,
				ded_amt		DECIMAL(8,2)
			END RECORD,
			pr_all_amt,
			pr_ded_amt		DECIMAL(10,2),
			idx, idx1, idx_a				INTEGER,
			pay_mth,
			pr_paymode		CHAR(20),
			esc_seq                 CHAR(20),
            
            ldgr_ded_desc, ldgr_all_desc CHAR(30),
            ldgr_ded_amt, ldgr_all_amt MONEY(16,2),
            company_desc    LIKE company.name_text,
            g_pack          CHAR(40)
            
		
	OUTPUT	LEFT MARGIN	0
			TOP MARGIN	0
			PAGE LENGTH 60
			RIGHT MARGIN	132

	ORDER EXTERNAL BY pr_employee.old_dept

	FORMAT

    PAGE HEADER
    
	BEFORE GROUP OF pr_employee.old_dept
--	SKIP TO TOP OF PAGE

	--ON EVERY ROW
    
    
	CASE pr_empayprd.pay_mode
	WHEN "1"
		LET pr_paymode = "Tunai"
	WHEN "2"
		LET pr_paymode = "Cek"
	WHEN "3"
		LET pr_paymode = "Kredit Bank ",pr_empayprd.bank_code
	END CASE
    
    

	LET pr_all_amt = 0
	LET pr_ded_amt = 0
	FOR idx = 1 TO 27
		INITIALIZE pa_empayldgr[idx].* TO NULL
	END FOR

	SELECT post_desc INTO pr_post.post_desc FROM post
	WHERE post_code = pr_employee.emp_post

	IF STATUS = NOTFOUND THEN
       LET pr_post.post_desc = NULL
	END IF

	SELECT short_desc INTO pr_bank.short_desc
	FROM   bank
	WHERE  cmpy_code = cmpy
	AND    bank_code = pr_empayprd.bank_code

	IF STATUS = NOTFOUND THEN
       LET pr_bank.short_desc = NULL
	END IF

	SELECT desc
	INTO   pr_tempcost.desc 
    FROM   tempcost
	WHERE  old_cost = pr_employee.old_dept
    
	IF STATUS = NOTFOUND THEN
       LET pr_tempcost.desc = NULL
	END IF

	IF pr_tempcost.desc IS NULL THEN 
        SELECT a.desc
		INTO   pr_tempcost.desc FROM tempcost a
		WHERE  a.new_cost = pr_employee.emp_dept

		IF STATUS = NOTFOUND THEN
       	   LET pr_tempcost.desc = NULL
		END IF
	END IF 
    
    IF pr_empayprd.post_type ="A" AND cmpy[1,2]= "SA" THEN
       LET cmpy ="SA"
    ELSE
       LET cmpy= cmpy
    END IF
    
    SELECT count(ad_code) INTO cnt_ptg
    FROM empayldgr
    WHERE   emp_no  = n_get_emp_no 
    AND     pay_prd = pr_empayprd.pay_prd 
    AND     post_type = pr_empayprd.post_type 
    AND     user_cmpy = pr_empayprd.user_cmpy   #cmpy 23/01/2010
    AND ad_code IN (SELECT a.ad_code FROM allded a
                    WHERE a.ad_type = "P") 
    
    
    
    
    IF cnt_ptg > 18 THEN
        LET idx_p = cnt_ptg
    ELSE
        LET idx_p = 18
    END IF   
		
	DECLARE c_empayldgr1 CURSOR FOR
	SELECT * FROM empayldgr
	WHERE 	emp_no  = n_get_emp_no 
    AND     pay_prd = pr_empayprd.pay_prd 
    AND     post_type = pr_empayprd.post_type 
    AND     user_cmpy = pr_empayprd.user_cmpy   #cmpy 23/01/2010
    ORDER BY empayldgr.ad_code
    

	FOREACH c_empayldgr1 INTO pr_empayldgr.*
    SELECT  ad_type,short_desc 
    INTO    pr_allded.ad_type,pr_allded.short_desc
    FROM    allded 
    WHERE   ad_code = pr_empayldgr.ad_code

    IF pr_employee.group_code = "S" AND pr_employee.work_shift="Y" THEN

    CALL shortdesc(pr_allded.short_desc) RETURNING g_pack  
    LET pr_allded.short_desc = g_pack
    
    END IF

		CASE pr_allded.ad_type
		WHEN "E"
		  FOR idx = 1 to idx_p
		    IF pa_empayldgr[idx].all_desc IS NULL THEN
			   IF pr_empayldgr.ad_year <> YEAR(pr_empayldgr.pay_prd) THEN
				  LET pa_empayldgr[idx].all_desc = 
					  pr_allded.short_desc[1,22] CLIPPED," ",
				      pr_empayldgr.ad_year USING "<<<<"
                 -- LET pa_empayldgr[idx].all_desc = pr_allded.short_desc --CLIPPED, " - (", pr_empayldgr.user_cmpy CLIPPED,")"
			   ELSE 	
			      --LET pa_empayldgr[idx].all_desc = pr_allded.short_desc
                  LET pa_empayldgr[idx].all_desc = pr_allded.short_desc --CLIPPED, " - (", pr_empayldgr.user_cmpy CLIPPED,")"
			   END IF 	
			   LET pa_empayldgr[idx].all_amt = pr_empayldgr.ad_amt
              -- LET pa_empayldgr[idx].all_desc = pr_allded.short_desc --CLIPPED, " - (", pr_empayldgr.user_cmpy CLIPPED,")"
               EXIT FOR
		    END IF
		  END FOR
		  LET pr_all_amt = pr_all_amt + pr_empayldgr.ad_amt
		WHEN "P"
		  FOR idx = 1 to idx_p
		    IF pa_empayldgr[idx].ded_desc IS NULL THEN
			   IF pr_empayldgr.ad_year <> YEAR(pr_empayldgr.pay_prd) THEN
				  LET pa_empayldgr[idx].ded_desc = 
				      pr_allded.short_desc[1,22] CLIPPED," ",
					  pr_empayldgr.ad_year USING "<<<<" 
			   ELSE 	
			      LET pa_empayldgr[idx].ded_desc = pr_allded.short_desc
			   END IF 	
			   LET pa_empayldgr[idx].ded_amt = pr_empayldgr.ad_amt
			   EXIT FOR
		    END IF
		  END FOR
		  LET pr_ded_amt = pr_ded_amt + pr_empayldgr.ad_amt
		END CASE
	END FOREACH
	--SKIP 9 LINE
     ##printing format##

PRINT " "
SKIP 5 LINE 
PRINT"
<html><head><style type='text/css'>
<!--.style1 {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 10px;
}
.style2 {font-family: Arial, Helvetica, sans-serif; font-size: 10px; font-weight: bold; }-->
</style>
</head>
<body>
<table width='100%' border='0' cellspacing='0' cellpadding='0' >
   <tr>
    
    <td width='9%' class='style1'><font color='#FFFFFF'>.&nbsp;</font></td>
    <td width='1%' class='style1'>&nbsp;</td>
    <td width='57%' class='style1'>&nbsp;</td>
    <td width='15%' class='style1'>&nbsp;</td>
    <td width='2%' class='style1'>&nbsp;</td>
    <td width='14%' class='style1'>&nbsp;</td>
  </tr>
  <tr>
    
    <td width='9%' class='style1'>NAMA</td>
    <td width='1%' class='style1'>:</td>
    <td width='57%' class='style1'> ",pr_employee.emp_name,"</td>
    <td width='15%' class='style1'>NO. PEKERJA</td>
    <td width='2%' class='style1'>:</td>
    <td width='14%' class='style1'>",pr_employee.emp_no USING "&&&&&&&&","</td>
  </tr>
  <tr>
		
		<td width='9%' 'style1'>NO. K/P</td>
		<td width='1%' class='style1'>:</td>
		<td width='57%' class='style1'>",pr_employee.old_ic_no," ","/"," ",pr_employee.new_ic_no,"</td>
		<td width='15%' class='style1'>NO. KWSP</td>
		<td width='2%' class='style1'>:</td>
		<td width='14%' class='style1'>",pr_employee.epf_no,"</td>
	  </tr> 
	
   <tr>
   
    <td width='9%' class='style1'>JABATAN</td>
    <td width='1%' class='style1'>:</td>
    <td width='57%' class='style1'>",pr_tempcost.desc[1,40],"</td>
    <td width='15%' class='style1'>NO. CUKAI</td>
    <td width='2%' class='style1'>:</td>
    <td width='14%' class='style1'>",pr_employee.tax_no,"</td>
  </tr>
   <tr>
    
    <td width='9%' class='style1'>JAWATAN</td>
    <td width='1%' class='style1'>:</td>
    <td width='57%' class='style1'>",pr_post.post_desc[1,35],"</td>
    <td width='15%' class='style1'>NO. PENCEN</td>
    <td width='2%' class='style1'>:</td>
    <td width='14%' class='style1'>",pr_employee.pens_no,"</td>
  </tr>
   <tr>
    
    <td width='9%' class='style1'>BULAN</td>
    <td width='1%' class='style1'>:</td>
    <td width='57%' class='style1'>",pay_mth,"</td>
    <td width='15%' class='style1'>&nbsp;</td>
    <td width='2%' class='style1'>&nbsp;</td>
    <td width='14%' class='style1'>&nbsp;</td>
  </tr>
  
</table>
<table width='100%' border='0' cellspacing='0' cellpadding='0'>
<tr>
    <td width='2%'><font color='#FFFFFF'>.&nbsp;</font></td>
    <td width='45%' class='style1'>&nbsp;</td>
    <td width='9%' class='style1'>&nbsp;</td>
    <td width='4%' class='style1'>&nbsp;</td>
    <td width='30%' class='style2'>&nbsp;</td>
    <td width='8%' class='style1'>&nbsp;</td>
    <td width='2%' class='style1'>&nbsp;</td>
  </tr> 
<tr>
    <td width='2%'>&nbsp;</td>
    <td width='45%' class='style1'>&nbsp;</td>
    <td width='9%' class='style1'>&nbsp;</td>
    <td width='4%' class='style1'>&nbsp;</td>
    <td width='30%' class='style2'>&nbsp;</td>
    <td width='8%' class='style1'>&nbsp;</td>
    <td width='2%' class='style1'>&nbsp;</td>
  </tr> 
<tr>
    <td width='2%'>&nbsp;</td>
    <td width='45%' class='style1' align='center'><strong>PENDAPATAN</strong></td>
    <td width='9%' class='style1' align='center'><strong>(RM)</strong></td>
    <td width='4%' class='style1'>&nbsp;</td>
    <td width='30%' class='style2' align='center'><strong>POTONGAN</strong></td>
    <td width='8%' class='style1' align='center'><strong>(RM)</strong></td>
    <td width='2%' class='style1'>&nbsp;</td>
  </tr> 
  "

FOR idx = 1 TO idx_p
   { IF pa_empayldgr[idx].all_desc IS NOT NULL or pa_empayldgr[idx].all_desc <>"" THEN 
        LET ldgr_all_desc = pa_empayldgr[idx].all_desc[1,22]
    ELSE
        LET ldgr_all_desc = NULL
    END IF
    
    IF pa_empayldgr[idx].all_amt IS NOT NULL or pa_empayldgr[idx].all_amt <>"" THEN 
        LET ldgr_all_amt = pa_empayldgr[idx].all_amt
    ELSE
        LET ldgr_all_amt = NULL
    END IF
    
    IF pa_empayldgr[idx].ded_desc[1,27] IS NOT NULL or pa_empayldgr[idx].ded_desc[1,27]<>"" THEN 
        LET ldgr_ded_desc = pa_empayldgr[idx].ded_desc[1,27]
    ELSE
        LET ldgr_ded_desc = NULL
    END IF
    
    IF pa_empayldgr[idx].ded_amt IS NOT NULL or pa_empayldgr[idx].ded_amt <>"" THEN 
        LET ldgr_ded_amt = pa_empayldgr[idx].ded_amt
    ELSE
        LET ldgr_ded_amt = NULL
    END IF
    }
    

PRINT "
<tr>
    <td width='2%'><font color='#FFFFFF'>.&nbsp;</font></td>
    <td width='45%' class='style1' > ",pa_empayldgr[idx].all_desc,"</td>
    <td width='9%' class='style1' align='right'>",pa_empayldgr[idx].all_amt USING "##,###.&&","&nbsp;</td>
    <td width='4%' class='style1'> &nbsp;</td>
    <td width='30%' class='style1'> ",pa_empayldgr[idx].ded_desc[1,27],"</td>
    <td width='8%' class='style1' align='right'>",pa_empayldgr[idx].ded_amt USING "##,###.&&","&nbsp;</td>
    <td width='2%' class='style1'> &nbsp;</td>
  </tr> "
 END FOR
 
 IF pr_empayprd.emper_epf = 0 THEN
		LET pr_empayprd.emper_epf = NULL
	END IF

	IF pr_empayprd.pens_amt = 0 THEN
		LET pr_empayprd.pens_amt = NULL
	END IF

	IF pr_empayprd.emper_socso = 0 THEN
		LET pr_empayprd.emper_socso = NULL
	END IF
    
   IF pr_empayprd.post_type = "A" THEN
   SELECT payslipdate.date
   INTO   pr_paydate
   FROM   payslipdate
   WHERE  payslipdate.month = pr_empayprd.pay_prd
   AND    payslipdate.post_type = pr_empayprd.post_type
   AND    payslipdate.cmpy_code = "SA" 
   ELSE
   IF pr_empayprd.post_type = "T" THEN
   SELECT payslipdate.date
   INTO   pr_paydate
   FROM   payslipdate
   WHERE  payslipdate.month = pr_empayprd.pay_prd
   AND    payslipdate.post_type = pr_empayprd.post_type
   AND    payslipdate.cmpy_code = "SA" 
   ELSE
   SELECT payslipdate.date
   INTO   pr_paydate
   FROM   payslipdate
   WHERE  payslipdate.month = pr_empayprd.pay_prd
   AND    payslipdate.post_type = pr_empayprd.post_type
   AND    payslipdate.cmpy_code = cmpy 
   END IF
   END IF
         
   IF pr_paydate =0  THEN
      LET pr_paydate = NULL
    END IF 
    
   SELECT UPPER(company.name_text)
   INTO company_desc
   FROM company
   WHERE company.cmpy_code = pr_empayprd.user_cmpy

IF  pr_empayprd.post_type = 'D' THEN
 
    PRINT "   
    </table>

    <table width='100%' border='0' cellspacing='0' cellpadding='0'>
    <tr>
        <td colspan='3' class='style1'><strong>KUMPULAN WANG &nbsp;&nbsp;:&nbsp;&nbsp; ",company_desc,"</strong></td>
      </tr>
    <tr>"
ELSE
    PRINT "   
    </table>

    <table width='100%' border='0' cellspacing='0' cellpadding='0'>
    <tr>
        <td colspan='3' class='style1'>&nbsp;.</td>
      </tr>
    <tr>"
END IF

PRINT "
<tr>
    <td colspan='3' class='style1'><strong>CARUMAN (MAJIKAN)</strong></td>
  </tr>
<tr>
   
    <td width='11%' class='style1'><strong>KWSP</strong></td>
    <td width='2%' class='style1'>:</td>
    <td width='87%'>",pr_empayprd.emper_epf,"&nbsp;</td>
</tr>
<tr>
  
   <td width='11%' class='style1'><strong>PENCEN</strong></td>
    <td width='2%' class='style1'>:</td>
    <td width='87%'>",pr_empayprd.pens_amt USING "--,--&.&&","&nbsp;</td>
</tr>
<tr>
   
    <td width='11%' class='style1'><strong>SOCSO</strong></td>
    <td width='2%' class='style1'>:</td>
    <td width='87%'>",pr_empayprd.emper_socso,"&nbsp;</td>
</tr>
</table>


<table width='100%' border='0' cellspacing='0' cellpadding='0'>
  <tr>
    <td colspan='7'>&nbsp;</td>
  </tr>
  <tr>

    <td width='23%' class='style1'><strong>JUMLAH PENDAPATAN</strong></td>
    <td width='2%' class='style1'>:</td>
    <td width='30%' class='style1'>RM ",pr_all_amt USING "---,--&.&&","</td>
    <td width='23%' class='style1'><strong>JUMLAH POTONGAN</strong></td>
    <td width='2%' class='style1'>:</td>
    <td width='18%' class='style1'>RM ",pr_ded_amt USING "---,--&.&&","</td>
  </tr>
  <tr>

    <td height='12' width='23%' class='style1'><strong>TARIKH GAJI</strong></td>
    <td height='12' width='2%' class='style1'>:</td>
    <td height='12' width='30%' class='style1'>",pr_paydate USING "DD/MM/YYYY","</td>
    <td height='12' width='23%' class='style1'><strong>JUMLAH GAJI BERSIH</strong></td>
    <td height='12' width='1%' class='style1'>:</td>
    <td height='12' width='18%' class='style1'>RM ",pr_all_amt - pr_ded_amt USING "---,--&.&&","</td>
  </tr>
  <tr>

    <td height='12' width='23%' class='style2'><strong>CARA PEMBAYARAN</strong></td>
    <td height='12' width='2%' class='style1'>:</td>
    <td height='12' width='30%' class='style1'>",pr_bank.short_desc CLIPPED," ",pr_empayprd.bank_acct_num,"</td>
    <td height='12' colspan='3' class='style1'><strong><em>Terima Kasih kerana menyimpan penyata ini</em></strong></td>
  </tr>
    <tr>
    <td height='12' colspan='7' class='style1'>&nbsp;</td>
  </tr>
  <tr>
    <td height='12' colspan='7' class='style1'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Dokumen Ini Tidak Sah Digunakan Tanpa Pengesahan Pejabat Bendahari</td>
  </tr>
</table>
</body></html>"


END REPORT

FUNCTION shortdesc(g_char_text)                               
                                                          
        DEFINE g_pack,shortdesc,                                    
                g_char_text     char(40),                 
                g_char,prefix          char(1),           
                counter_i,                                
                bil_word,                                 
                counter         smallint                  
                                                          
                                                          
        LET bil_word = length(g_char_text)                
        LET g_pack = " "                                  
                                                          
        FOR counter = 1 TO bil_word                       
        
                                               
        LET g_char = g_char_text[counter,counter]  
          
        IF g_char = "(" THEN  
            #LET bil_word = counter - 1  
            #LET g_char = g_char_text[counter,counter-1] 
            EXIT FOR 
        END IF         
        
        IF g_char != "(" THEN      
            LET shortdesc = shortdesc clipped,g_char clipped
        END IF 
        
        IF counter > 2 THEN
        IF g_char_text[counter-1]= " " THEN      
            LET shortdesc[counter-1,counter] =g_char_text[counter-1],g_char clipped
        END IF
        END IF 
        
        {IF g_char = " " THEN                             
                LET shortdesc = shortdesc,g_char
        END IF   } 
                                                
        END FOR                                           
                                                          
        LET prefix = " "                                  
        LET g_pack =shortdesc
        RETURN g_pack                
                                     
END FUNCTION  


 